/*
 * stm32_helper.h
 *
 *  Created on: 05.02.2015
 *      Author: Bernd
 */

#ifndef STM32F401RE_MINIMAL_INC_STM32_MISC_H_
#define STM32F401RE_MINIMAL_INC_STM32_MISC_H_

#define SHIFT1(PIN)                (1 << PIN)
#define SHIFT2(PIN, MASK)          (MASK << (PIN << 1))
#define SHIFT4(PIN, MASK)          (MASK << (PIN << 2))

/**
 * GPIO
 */

#define GPIO_MODER_INPUT            0b00UL
#define GPIO_MODER_OUTPUT           0b01UL
#define GPIO_MODER_ALTERNATE        0b10UL
#define GPIO_MODER_ANALOG           0b11UL

#define GPIO_OSPEEDR_LOW            0b00UL
#define GPIO_OSPEEDR_MEDIUM         0b01UL
#define GPIO_OSPEEDR_HIGH           0b11UL

#define GPIO_SET(PORT, PIN)         PORT->BSRRL = SHIFT1(PIN)
#define GPIO_CLR(PORT, PIN)         PORT->BSRRH = SHIFT1(PIN)
#define GPIO_TGL(PORT, PIN)         PORT->ODR = PORT->ODR ^= SHIFT1(PIN)

#endif /* STM32F401RE_MINIMAL_INC_STM32_MISC_H_ */
